package de.sh_edraft.events

import de.sh_edraft.data.DataService
import org.bukkit.event.EventHandler
import org.bukkit.event.Listener
import org.bukkit.event.player.PlayerEvent
import org.bukkit.event.player.PlayerKickEvent
import org.bukkit.event.player.PlayerQuitEvent
import java.util.logging.Logger

class OnLeftListener(
    private val logger: Logger,
    private val dataService: DataService
) : Listener {

    private fun handleQuit(p: PlayerEvent) {
        if (p.player.player ==  null) {
            return;
        }
        val playerId = this.dataService.getPlayerGlobalId(p.player.player!!.displayName) ?: return;
        this.dataService.sendLeftPlayer(playerId);
    }

    @EventHandler
    fun onPlayerQuit(p: PlayerQuitEvent) {
        this.handleQuit(p)
    }

    @EventHandler
    fun onPlayerKick(p: PlayerKickEvent) {
        this.handleQuit(p)
    }
}